src/Modwana.Web/ViewModels/BlogViewModel.cs
using Modwana.Core.Resources;
using Modwana.Domain.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace Modwana.Web.ViewModels
{
    public class BlogViewModel : ViewModelBase<Blog>
    {
        [Display(Name = nameof(CommonText.Title), ResourceType = typeof(CommonText))]
        [Required(ErrorMessageResourceName = nameof(ValidationText.Required), ErrorMessageResourceType = typeof(ValidationText))]
        public string Title { get; set; }

        [Display(Name = nameof(CommonText.Text), ResourceType = typeof(CommonText))]
        [Required(ErrorMessageResourceName = nameof(ValidationText.Required), ErrorMessageResourceType = typeof(ValidationText))]
        public string Body { get; set; }

        public BlogViewModel()
        {

        }

        public BlogViewModel(Blog entity)
        {
            Id = entity.Id;
            Title = entity.Title;
            Body = entity.Body;
        }

        public override Blog ToModel()
        {
            return new Blog()
            {
                Id = Id,
                Body = Body,
                Title = Title,
            };
        }
    }
}

src/Modwana.Web/Controllers/BlogController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Modwana.Core.Exceptions;
using Modwana.Domain.Models;
using Modwana.Domain.Services;
using Modwana.Web.ViewModels;

namespace Modwana.Web.Controllers
{
    public class BlogController : BaseController
    {
        private readonly IBlogService _service;

        public BlogController(IBlogService service)
        {
            _service = service;
        }

        public async Task<IActionResult> Index(BlogSearchViewModel model)
        {
            var result = await _service.Search(model.ToSearchModel());

            if (IsAjaxRequest())
                return PartialView("_List", result);

            return View(result);
        }

        [Authorize]
        public IActionResult Add()
        {
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize]
        public async Task<IActionResult> Add(BlogViewModel model)
        {
            Blog blog;

            try
            {
                ValidateModelState();

                blog = await _service.Add(model.ToModel());

                SetSuccess();
            }
            catch (BusinessException ex)
            {
                SetError(ex);

                return View(model);
            }

            return RedirectToAction("details",new { id = blog.Id });
        }

        [Authorize]
        public async Task<IActionResult> Edit(string id)
        {
            var model = await _service.GetById(id);

            if (model == null)
                return NotFound();

            return View(model);
        }

        [Authorize]
        public async Task<IActionResult> Update(BlogViewModel model)
        {
            try
            {
                var blog = await _service.GetById(model.Id);

                blog = blog.Update(model.ToModel());

                await _service.Save(blog);

                SetSuccess();
            }
            catch (BusinessException ex)
            {
                SetError(ex);

                return View("Edit", model);
            }

            return RedirectToAction("index");
        }

        public async Task<IActionResult> Details(string id)
        {
            var blog = await _service.GetById(id);

            if (blog == null)
                return NotFound();

            return View(blog);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Delete(string id)
        {
            try
            {
                await _service.Delete(id);

                SetSuccess();
            }
            catch (BusinessException ex)
            {
                SetError(ex);

                return RedirectToAction("Edit", new { id });
            }

            return RedirectToAction("index");
        }
    }
}

src/Modwana.Web/Controllers/CommentController.cs
using Microsoft.AspNetCore.Mvc;
using Modwana.Core.Exceptions;
using Modwana.Domain.Services;
using Modwana.Web.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Modwana.Web.Controllers
{
    public class CommentController : BaseController
    {

        private readonly ICommentService _service;

        public CommentController(ICommentService service)
        {
            _service = service;
        }

        public async Task<IActionResult> List(CommentSearchViewModel model)
        {
            var result = await _service.Search(model.ToSearchModel());

            return PartialView("_List", result);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public Task<IActionResult> Add(CommentViewModel model)
        {
            return AjaxTask(async () =>
            {
                var comment = model.ToModel();

                comment.UserAgent = HttpContext.Request.Headers["UserAgent"];
                comment.IPAddress = HttpContext.Connection.RemoteIpAddress?.ToString();

                await _service.Add(model.ToModel());
            });
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public Task<IActionResult> Delete(string id)
        {
            return AjaxTask(async () =>
            {
                await _service.Delete(id);
            });
        }
    }
}

src/Modwana.Web/Views/Blog/Add.cshtml
@{
    ViewData["Title"] = CommonText.AddPost;
}

@section styles{

    <link href="~/lib/tinymc/skins/lightgray/skin.min.css" rel="stylesheet" />
    <link href="~/lib/tinymc/plugins/codesample/css/prism.min.css" rel="stylesheet" />
}


@section top{

    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item">
                <a href="/">
                    @CommonText.Blogs
                </a>
            </li>
            <li class="breadcrumb-item active" aria-current="page">
                @CommonText.AddPost
            </li>
        </ol>
    </nav>

}

<div class="card">
    <div class="card-body">

        <form method="post"
              asp-action="add">
            <partial name="_Form" model="new BlogViewModel()" />
            <hr />
            <button type="submit" class="btn btn-success btn-sm">
                <i class="fa fa-plus"></i>
                @CommonText.Add
            </button>
            <a asp-action="index" class="btn btn-sm btn-outline-danger">
                <i class="fa fa-ban"></i>
                @CommonText.Cancel
            </a>
        </form>
    </div>
</div>


@section scripts{

    <partial name="Parts/_Js" />
}

src/Modwana.Web/Views/Blog/Details.cshtml
@model Blog
@{
    ViewData["Title"] = Model.Title;
}

@section styles{

    <link href="~/prism/prism.css" rel="stylesheet" />

}

@section top{


    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item">
                <a href="/">
                    @CommonText.Blogs
                </a>
            </li>
            <li class="breadcrumb-item active" aria-current="page">
                @Model.Title?.Brief(20)
            </li>
        </ol>
    </nav>
}

<div class="card blog">
    <div class="card-body">

        <h2 class="card-title">
            @Model.Title
        </h2>
        <ul class="list-inline">
            <li class="list-inline-item">
                <i class="fa fa-user-o"></i>
                @Model.Author?.Name
            </li>
            <li class="list-inline-item text-muted">
                <i class="fa fa-calendar-o"></i>
                @Model.CreatedDate.ToSystemDate()
            </li>
            <li class="list-inline-item">
                <i class="fa fa-comment-o"></i>
                @Model.NumberOfComments
            </li>

        </ul>

        @Html.Raw(Model.Body)


    </div>
</div>

<div class="card blog" id="comment-card">
    <div class="card-body">
        <h4 class="card-title">
            @CommonText.LeaveReply
        </h4>
        <form id="comment-form"
              method="post"
              asp-ajax="true"
              asp-ajax-success-method="updateListFromDiv('#comment-list');clearFromData('#comment-form')"
              asp-action="add"
              asp-controller="comment"
              asp-ajax-block="#comment-card">

            <partial name="~/Views/Comment/_Form.cshtml" model="new CommentViewModel(Model.Id)" />

            <hr />

            <button type="submit" class="btn btn-primary btn-sm">
                @CommonText.PostComment
            </button>
        </form>
    </div>
</div>

<div class="card blog">
    <div class="card-body">
        <h4 class="card-title">
            @CommonText.Comments
        </h4>
        <hr/>
        <div id="comment-list"></div>
    </div>
</div>

@if (User.Identity.IsAuthenticated)
{
    <div class="card">
        <div class="card-body">
            <a asp-action="edit" asp-route-id="@Model.Id" class="btn btn-info btn-sm">
                <i class="fa fa-edit"></i>
                @CommonText.Edit
            </a>

        </div>
    </div>
}

@section scripts{
    <script src="~/prism/prism.js"></script>

    <script type="text/javascript">

        $(function () {

            updateComments();
        });

        function updateComments() {

            var url = '@Url.Action("List", "Comment", new { BlogId = Model.Id })';

            updateContainer(url, "#comment-list")
        }

    </script>
}

src/Modwana.Web/Views/Blog/Edit.cshtml
@model Blog
@{
    ViewData["Title"] = CommonText.Edit;
}



@section styles{

    <link href="~/lib/tinymc/skins/lightgray/skin.min.css" rel="stylesheet" />
    <link href="~/lib/tinymc/plugins/codesample/css/prism.min.css" rel="stylesheet" />
}


@section top{


    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item">
                <a href="/">
                    @CommonText.Blogs
                </a>
            </li>
            <li class="breadcrumb-item active" aria-current="page">
                @CommonText.Edit
            </li>
        </ol>
    </nav>
}

<div class="card">
    <div class="card-body">
        <a asp-action="delete"
           asp-confirm="true"
           asp-route-id="@Model.Id"
           class="btn btn-sm btn-danger float-right"
           style="margin-bottom:5px;">
            <i class="fa fa-trash"></i>
            @CommonText.Delete
        </a>
        <form method="post"
              asp-action="update">
            <partial name="_Form" model="new BlogViewModel(Model)" />
            <hr />
            <button type="submit" class="btn btn-success btn-sm">
                <i class="fa fa-save"></i>
                @CommonText.Save
            </button>
            <a asp-action="index" class="btn btn-outline-danger btn-sm">
                <i class="fa fa-ban"></i>
                @CommonText.Cancel
            </a>
        </form>
    </div>
</div>


@section scripts{

    <partial name="Parts/_Js" />
}

src/Modwana.Web/Views/Blog/Index.cshtml
@model SearchResult<Blog>

@{
    ViewData["Title"] = CommonText.Blogs;
}

<div id="list">
    <partial name="_List" />
</div>

src/Modwana.Web/Views/Blog/_Form.cshtml
@model BlogViewModel

<input type="hidden" asp-for="Id"/>

<bootstrap-input-form-group asp-for="Title" />


<div class="form-group">
    <label for="Body">
        @CommonText.Text *
        <span asp-validation-for="Body"></span>
    </label>
    
    <textarea id="editor" asp-for="Body" class="form-control" rows="20"></textarea>
</div>

src/Modwana.Web/Views/Blog/_List.cshtml
@model SearchResult<Blog>

@{
    var search = Model.SearchCriteria as BlogSearchViewModel;
}

@if (Model.Result.Any())
{

    @foreach (var item in Model.Result)
    {

        <partial name="Parts/_Item" model="item" />

    }



    <cs-pager cs-pager-ul-class="pagination pagination-sm"
              cs-pager-li-other-class="page-item"
              cs-pager-link-other-class="page-link"
              cs-pager-li-current-class="page-item active"
              cs-pager-link-current-class="page-link"
              cs-paging-pagesize="@Model.PageSize"
              cs-paging-pagenumber="@Model.PageNumber"
              cs-paging-totalitems="@Model.TotalResultsCount"
              asp-all-route-data="@search.ToRouteValueDictionary()"
              cs-ajax-target="#list"
              cs-ajax-begin="block('#list')"
              cs-ajax-complete="unblock('#list')"
              asp-controller="Blog"
              asp-action="Index">

    </cs-pager>
    <strong>
        @CommonText.Total:
    </strong>
    @Model.TotalResultsCount.ToString("N0")
}
else
{
    <div class="alert alert-info" role="alert">
        <h4 class="alert-heading">
            لم يتم العثور على المدونة
        </h4>
        <hr>
        <p>
            لم تقم باضافة اي مدونة, بامكانك اضافة مدونة جديدة من خلال
            <a asp-action="add" asp-controller="blog">
                الضغط هنا
            </a>
        </p>

    </div>
}


<input type="hidden" data-route value="@Url.RouteUrl(search.ToRouteValueDictionary(true))" />